# Rudimentary soil model primarily for vertical stresses under level ground.
I think, I have made a simple calculation very complicated, but what is done is now done. Define soil layers, assemble them into soil profile and compute total vertical stresses, pore pressures, and effective vertical stresses at specified locations beneath a level ground. In addition, return requested soil parameters at specified depths. One can use these parameters at specified depths to perform futher analysis. This is a work in progress.

## Documentation
[geostress documentation](https://geosharma.gitlab.io/geostress/)


## References:
 - [Maxim Millen's eng-tools](https://github.com/eng-tools)
 - [Nico Schlömer and others pygmsh](https://github.com/nschloe/pygmsh)
 - [Albert Kottke's pysra](https://github.com/arkottke/pysra)
 - [note.nkmk.me](https://note.nkmk.me/en/python-pip-install-requirements/)

## Usage
This package lacks a good documentation. I am in the process of learning how to create documentation from python docstrings. I am a slow learner so I take baby steps. Once that is up, maybe I will include few examples in the documentation. Untill then please refer to the `tests` and the `examples` folders.

## Requirements
Only Python and Numpy are required for the package:
 - python
 - numpy

However, additional packages are required to run the example files and tests with `pytest`.
 - pandas
 - matplotlib
 - altair
 - hancalcs
 - pytest


# Local installation in virtual environment
1. Make a `.venv` directory in the project folder.
2. Make a virtual environment `python -m venv .venv`
3. Activate the virtual environment `source .venv/bin/activate`
4. Install the requirements `python -m pip install -r requirements.txt`
5. Install the package locally `pip install -e .`

Above (4) and (5) are run after activating the virtual environment. This will install the package to the virtual environment. Any changes your make to the source code will be reflected in the package.


## Installation

I have a version uploaded to pypi `pip install pyvstress`

If installing packages from TestPyPi then `$ pip install --index-url https://test.pypi.org/simple/packagename`

